mat4 unpackMatrix(float id)
{
	vec4 a1,a2,a3,a4;
	a1 = texture2D(BoneMatrixArray,vec2( (id+0.5)/BoneNumberM4 , 3.5/4.0 )).rgba;
	a2 = texture2D(BoneMatrixArray,vec2( (id+0.5)/BoneNumberM4 , 2.5/4.0 )).rgba;
	a3 = texture2D(BoneMatrixArray,vec2( (id+0.5)/BoneNumberM4 , 1.5/4.0 )).rgba;
	a4 = texture2D(BoneMatrixArray,vec2( (id+0.5)/BoneNumberM4 , 0.5/4.0 )).rgba;
	return mat4(a1,a2,a3,a4);
}

vec4 getPosition()
{
	mat4 my_BoneMatrix0,my_BoneMatrix1;
	mat4 tempMatrix;

	my_Vertex = vec4(vPosition, 1.0);
	if(fBone0Weight>0.99){
		my_BoneMatrix0=unpackMatrix(iBone0);
		return gl_ModelViewProjectionMatrix*my_BoneMatrix0*my_Vertex;
    }
    else if(fBone0Weight<0.01){
		my_BoneMatrix1=unpackMatrix(iBone1);
		return gl_ModelViewProjectionMatrix*my_BoneMatrix1*my_Vertex;
    }
    else{
		my_BoneMatrix0=unpackMatrix(iBone0);
		my_BoneMatrix1=unpackMatrix(iBone1);
		tempMatrix = (
            my_BoneMatrix0*fBone0Weight+
            my_BoneMatrix1*(1.0-fBone0Weight)
            );
		return gl_ModelViewProjectionMatrix * tempMatrix * my_Vertex;
    }
}